#include <rccl.h>
#include "manex.560.h"

#ifdef Vxw_TARGET
#define main simple_560_
#endif

main()
{
        TRSF_PTR p, t;                                          /*1*/
        POS_PTR pos;                                            /*2*/
        MANIP *mnp;                                             /*3*/
        JNTS demohome;                                          /*4*/
        char *robotName;                                        /*5*/

        rcclSetOptions (RCCL_ERROR_EXIT);                       /*6*/
        robotName = getDefaultRobot();                          /*7*/
        if (!getRobotPosition (demohome.v, "demohome", robotName))
         { printf ("position 'demohome' not defined for robot\n");
           exit(-1);
         }
                                                                /*8*/
        t = allocTransXyz ("T", UNDEF, 0.0, 200.0, 50.0);
        p = allocTrans("P", UNDEF);
        pos = makePosition ("pos", T6, EQ, p, t, NULL);         /*9*/

        mnp = rcclCreate (robotName, 0);                        /*10*/
        rcclStart();

	fwdKinematics (p, (unsigned *)0, demohome.v, mnp->kyn, NULL);

        movej (mnp, &demohome);                                 /*11*/

        setMod (mnp, 'c');                                      /*12*/
        move (mnp, pos);                                        /*13*/
        stop (mnp, 1000.0);

        movej (mnp, &demohome);                                 /*14*/
        stop (mnp, 1000.0);

        waitForCompleted (mnp);                                 /*15*/
        rcclRelease (YES);                                      /*16*/
}
