/* mc8const.h - common definitions and types for MC8-?SP-ISA */

#ifndef _MC8CONST_H_
#define _MC8CONST_H_

#include "coff21k.h"

#ifndef RET_OK
#define RET_OK 1
#endif

#ifndef RET_ERR
#define RET_ERR 0
#endif

/**************************/
/* Memory types           */
/**************************/
#define MEMINSTR 0x80000000L
#define MEMMASK  0x7FFFFFFFL
#define MEMWIDTHPM 6
#define MEMWIDTHDM 4
#define MEMWIDTHXM 6

/**************************/
/* 32-bit C compatibility */
/**************************/
#ifndef _32BITCC
#define PTRMDFR         far
#define HPTR            huge *
#else
#define PTRMDFR 
#define HPTR            *
#endif
#define PTR             PTRMDFR *

typedef unsigned char   UCHAR;
typedef unsigned short  USHORT;
typedef unsigned int    UINT;
typedef unsigned long   ULONG;

#if defined(__DLL__) || defined(_WINDLL)
#include <windows.h>    /* pick up standard <windows.h> definitions */
typedef char PTR        LPCHAR;
typedef short PTR       LPSHORT;
typedef float PTR       LPFLOAT;
typedef double PTR      LPDOUBLE;

typedef UCHAR PTR       LPUCHAR;
typedef USHORT PTR      LPUSHORT;
typedef ULONG PTR       LPULONG;
#else
typedef char PTR        LPCHAR;
typedef short PTR       LPSHORT;
typedef long PTR        LPLONG;
typedef float PTR       LPFLOAT;
typedef double PTR      LPDOUBLE;
typedef void PTR        LPVOID;

typedef UCHAR PTR       LPUCHAR;
typedef USHORT PTR      LPUSHORT;
typedef ULONG PTR       LPULONG;
#endif

/*************/
/* structs   */
/*************/
typedef struct mc8_st {
	long lAddr;			/* mc8-dsp/hsp-isa port address */
	short wIrq;			/* mc8-dsp/hsp-isa IRQ number */
	short wProc;		/* 0=21060, 1=21061, 2=21062, -1=none */
	long lMAddrXfer;	/* Address (in SHARC) of transfer bank */
	short wXferMax;		/* Max size of transfer bank */
	short wBoardVer;	/* Board hardware version: 1.00 = 100 */	
	/* COFF data pointers */
	COFF_HDR PTRMDFR *psCoffHdr;	/* Coff File Header information */
	SYMTBL HPTR psCoffSym;			/* Coff File Symbol Table */
	char PTRMDFR *szCoffStr;		/* Symbol String Table */
	SCNHDR PTRMDFR *psCoffSec;		/* Coff File Section information */
	long PTRMDFR *plSec;			/* Section Memory Address flags */
	/* Will want memory bank size stuff later... when variants occurr */
} mc8_struct;

#endif /* _MC8CONST_H_ */
