/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd and Vincent Hayward.	    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#ifndef _OLDFXNS_H_
#define _OLDFXNS_H_

/* A header file to preserve compatibility with the slightly earlier
   release of RCCL 
*/

#ifdef __cplusplus
extern "C"
{
#endif

#define assigndiff(a,b)		copyDiff(a,b)
#define assignforce(a,b)	copyForce(a,b)
#define assigntr(a,b)		copyTrsf(a,b)
#define assignvec(a,b)		copyVect(a,b)
#define cross(a,b)		crossVect(a,b)
#define df_to_tr(a,b)           diffToTrsf(a,b)
#define difftr(a,b)             transDiff(a,b)
#define dotVect(a,b)            dotVect(a,b)
#define evalfn(m,f)             runMotionFxn(m,f)
#define forcetr(a,b)            transForce(a,b)
#define invert(a,b)             invertTrsf(a,b)
#define monitor(m,f)		runMonitorFxn(m,f)
#define setconf(m,a)		setConf(m,a)
#define setime(m,a,b)		setTime(m,(double)(a),(double)(b))
#define setmod(m,a)		setMod(m,a)
#define setvel(m,a,b)		setCartVel(m,(double)(a),(double)(b))
#define tr_to_df(a,b)           trsfToDiff(a,b)
#define trmult(a,b,c)		multTrsf(a,b,c)
#define invMultRight(a,b,c)	multRiTrsf(a,b,c)
#define invMultLeft(a,b,c)	multLiTrsf(a,b,c)
#define unitVect(a,b)           unitVect(a,b)
#define trident(a)              identTrsf(a)

#define qmult(a,b,c)		multQtrn(a,b,c)
#define invQmultRight(a,b,c)	multRiQtrn(a,b,c)
#define invQmultLeft(a,b,c)	multLiQtrn(a,b,c)
#define qinvert(a,b)		invertQtrn(a,b)
#define qunit(a,b)		unitQtrn(a,b)
#define qmagnitude(a)		normQtrn(a)
#define transform_to_quaternion(a,b)	trsfToQtrn(a,b)
#define quaternion_to_transform(a,b)	qtrnToTrsf(a,b)
#define quaternion_to_velocity(a,b)	qtrnToVect(a,b)

#define flush_motions(m)	flushMotionQueue(m)
#define motion_scale(e)		motionScale(e)
#define motion_start_value(e)	motionStartCode(e)
#define motion_status(e)	motionStatus(e)
#define motion_stop_value(e)	motionStopCode(e)
#define pause(m,t,a)		pauseCurrentMotion(m,(double)(t),(double)(a))
#define resume(m)		resumeCurrentMotion(m)
#define set_motion_queue_size(s) setMotionQueueSize(s)
#define start_motion(e,c)	startMotion(e,c)
#define stop_current_motion(m,c) stopCurrentMotion(m,c)
#define stop_motion(e,c)	stopMotion(e,c)
#define wait_for_finish(e)	waitForStop(e)
#define wait_for_start(e)	waitForStart(e)
#define setspeed(m,s)		setSpeed(m,s)

typedef TRSF_ARGS		TRANS_ARGS;

#ifdef __cplusplus
}
#endif

#endif
