#ifndef _STRINGDEFS_H_
#define _STRINGDEFS_H_

#include <string.h>
#include "../h/protoDef.h"

#if defined(NO_MEMCPY) && !defined(NO_BCOPY_EITHER)
#define BCOPY(s1,s2,len)	bcopy(s1, s2, len)
#define BZERO(s1,len)		bzero(s1, len)
#define BCMP(s1,s2,len)		bcmp(s1, s2, len)
#else
#define BCOPY(s1,s2,len)	memcpy(s2, s1, len)
#define BZERO(s1,len)		memset(s1, 0, len)
#define BCMP(s1,s2,len)		memcmp(s1, s2, len)
#endif

#ifdef __cplusplus
extern "C"
{
#endif

char *copyofstr PROTO((const char*));
char *charIndex PROTO((const char*, int));
char *charRindex PROTO((const char*, int));

#if defined(NO_MEMCPY) && defined(NO_BCOPY_EITHER)
void *memcpy PROTO((void*, const void*, int));
int memcmp PROTO((const void*, const void*, int));
void *memset PROTO((void*, int, int));

#endif

#ifdef __cplusplus
}
#endif

#endif
