/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd.			    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#ifndef _VECTOR_H_
#define _VECTOR_H_

#include "../h/protoDef.h"

#ifndef NO_PROTOTYPES
#include <stdio.h>
#endif

#ifdef __cplusplus
extern "C"
{
#endif

extern double *addVd PROTO((double*, double*, double*, int));
extern double *subtractVd PROTO((double*, double*, double*, int));
extern double *scaleVd PROTO((double*, double, double*, int));
extern double *combineVd PROTO((double*,double,double*,double,double*,int));
extern double normVd PROTO((double*, int));
extern double norm1Vd PROTO((double*, int));
extern double norm2Vd PROTO((double*, int));
extern double normInfVd PROTO((double*, int));
extern double dotVd PROTO((double*, double*, int));
extern double *copyVd PROTO((double*, double*, int));
extern double *zeroVd PROTO((double*, int));

extern float *addVf PROTO((float*, float*, float*, int));
extern float *subtractVf PROTO((float*, float*, float*, int));
extern float *scaleVf PROTO((float*, double, float*, int));
extern float *combineVf PROTO((float*, double, float*, double, float*, int));
extern float normVf PROTO((float*, int));
extern float norm1Vf PROTO((float*, int));
extern float norm2Vf PROTO((float*, int));
extern float normInfVf PROTO((float*, int));
extern float dotVf PROTO((float*, float*, int));
extern float *copyVf PROTO((float*, float*, int));
extern float *zeroVf PROTO((float*, int));

extern int *addVi PROTO((int*, int*, int*, int));
extern int *subtractVi PROTO((int*, int*, int*, int));
extern int *scaleVi PROTO((int*, double, int*, int));
extern int *combineVi PROTO((int*,double,int*,double,int*,int));
extern double normVi PROTO((int*, int));
extern double norm1Vi PROTO((int*, int));
extern double norm2Vi PROTO((int*, int));
extern double normInfVi PROTO((int*, int));
extern double dotVi PROTO((int*, int*, int));
extern int *copyVi PROTO((int*, int*, int));
extern int *zeroVi PROTO((int*, int));

extern float *copyVdf PROTO((float*, double*, int));
extern double *copyVfd PROTO((double*, float*, int));
extern float *copyVif PROTO((float*, int*, int));
extern int *copyVfi PROTO((int*, float*, int));
extern double *copyVid PROTO((double*, int*, int));
extern int *copyVdi PROTO((int*, double*, int));

extern int printVd PROTO((const char*, double*, int));
extern int fprintVd PROTO((FILE*, const char*, double*, int));
extern int scanVd PROTO((double*, int));
extern int fscanVd PROTO((FILE*, double*, int));
extern int printVf PROTO((const char*, float*, int));
extern int fprintVf PROTO((FILE*, const char*, float*, int));
extern int printJf PROTO((const char*, float*, int));
extern int fprintJf PROTO((FILE*, const char*, float*, int));
extern int scanVf PROTO((float*, int));
extern int fscanVf PROTO((FILE*, float*, int));
extern int printVi PROTO((const char*, int*, int));
extern int fprintVi PROTO((FILE*, const char*, int*, int));
extern int scanVi PROTO((int*, int));
extern int fscanVi PROTO((FILE*, int*, int));

#ifdef __cplusplus
}
#endif

#endif
