#if defined(X86sol_TARGET) || defined(Sun4sol_TARGET)
#define RESTRICTED_HOSTS	1

#include <stdio.h>
#include <string.h>

#include <sys/types.h>
#include <sys/priocntl.h>
#include <sys/rtpriocntl.h>
#include <sys/tspriocntl.h>
#include <sys/iapriocntl.h>
#include <sys/lwp.h>
#include <sys/mman.h>
#include <sys/systeminfo.h>
#include <errno.h>

char *hostList[] = {
	"zima",
	(char*)0 };

id_t schedinfo (name, maxpri)
char *name;
int *maxpri;
{
	pcinfo_t info;
	int nc;

	(void) strcpy (info.pc_clname, name);
	nc = priocntl (0L, 0L, PC_GETCID, (caddr_t)&info);

	if (nc == -1L)
	 { return (-1);
	 }
	if (strcmp ("RT", name) == 0)
	 { rtinfo_t *rtinfop;
	   rtinfop = (rtinfo_t*)&info.pc_clinfo;
	   if (maxpri)
	    { *maxpri = rtinfop->rt_maxpri;
	    }
	 }
	else if (strcmp ("TS", name) == 0)
	 { tsinfo_t *tsinfop;
	   tsinfop = (tsinfo_t*)&info.pc_clinfo;
	   if (maxpri)
	    { *maxpri = tsinfop->ts_maxupri;
	    }
	 }
	else if (strcmp ("IA", name) == 0)
	 { iainfo_t *iainfop;
	   iainfop = (iainfo_t*)&info.pc_clinfo;
	   if (maxpri)
	    { *maxpri = iainfop->ia_maxupri;
	    }
	 }
	else
	 { errno = EINVAL;
	   return (-1);
	 }
	return (info.pc_cid);
}

char **argvec;

main(argc, argv)
int argc;
char **argv;
{
	pcparms_t pcparms;
	rtparms_t *rtparmsp;
	id_t pid, rtID;
	id_t schedinfo();
	int maxrtpri;

	argvec = argv;
	argc--; argv++;

	if (argc != 1)
	 { fprintf (stderr, "Usage: %s <pid>\n", *argvec);
	   exit (1);
	 }
	if ((pid = atoi(*argv)) <= 0)
	 { fprintf (stderr, "%s: bad process id specification\n", *argvec);
	   exit (2);
	 }
#if RESTRICTED_HOSTS
#define BUFSIZE 256
	 { char buf[BUFSIZE];
	   char **np;

	   sysinfo (SI_HOSTNAME, buf, BUFSIZE);
	   for (np=hostList; *np != (char*)0; np++)
	    { printf ("%s %s\n", *np, buf);
	      if (strncmp (buf, *np, strlen(*np)) == 0)
	       { break;
	       }
	    }
	   if (*np == (char*)0)
	    { fprintf (stderr, "%s: cannot run on this host\n", *argvec);
	      exit (4);
	    }
	 }
#endif
	if ((rtID = schedinfo ("RT", &maxrtpri)) == -1)
	 { perror ("schedinfo for RT");
	   exit (3);
	 }
	pcparms.pc_cid = rtID;
	rtparmsp = (struct rtparms*)&pcparms.pc_clparms;
	rtparmsp->rt_pri = maxrtpri-1;
	rtparmsp->rt_tqsecs = 0;
	rtparmsp->rt_tqnsecs = RT_TQDEF;
	if (priocntl (P_PID, pid, PC_SETPARMS, (caddr_t)&pcparms) == -1L)
	 { perror ("priocntl PC_SETPARMS");
	 }
}
#endif

