/* Test running the Ctree matcher inside a Motif Text widget */
#ifdef HAS_X11_MOTIF
#include <Xm/Text.h>

#include "../h/ctree.h"
#include "../h/ctreeMotif.h"

char key_buf [256];

void ctreeCB (key_buf, data, fin, fout)
char *key_buf;
void *data;
FILE *fin;
FILE *fout;
{
	fprintf (fout, "Enter theta\n");
	fprintf (fout, "Command entered: %s\n", key_buf);
}

main(argc, argv)
int argc;
char **argv;
{
	Widget toplevel;
	Widget ctreew;
	XtAppContext app;

	char *keytree;
	int joint;

	keytree = tree_match_parse("					\
(	quit								\
	[free lock]							\
	 (all-joints							\
	  one-joint							\
	   (%d",&joint,",1,6,		\"joint number (1 to 6)\")	\
	 )								\
	show (encoder-values)						\
)",0);
	if (keytree == 0)
	 { printf ("ERROR/Parse error at %.30s\n", tree_match_err_at());
	   exit (-1);
	 }

	/* Set up the main application window that the text 
	   widget will be created under */

	toplevel = XtVaAppInitialize (&app, "Demos", 
	   NULL, 0, &argc, argv, NULL, NULL);

	ctreew = tree_match_motif_widget ("mtest", toplevel, app);

	tree_match_widget_init (keytree, "MTEST> ",key_buf,ctreeCB,(void*)0);

	XtRealizeWidget(toplevel);
	XtAppMainLoop(app);
}
#endif
