/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd.			    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#include <stdio.h>
#include <math.h>

#include "../h/cdefs.h"
#include "../h/robotClass.h"
#include "../h/linear_kynvar.h"
#include "../h/errorCodes.h"
#include "../h/errorStack.h"
#include "../h/robotMath.h"

#define EPSILONF 	1.0e-7

linear_kyn (kyn, fp)
KYN *kyn;
FILE *fp;
{
	LINEAR_KYN *skyn = (LINEAR_KYN*)kyn->ext;
	ConfCodeDesc *desc;

	char *fxnName = "linear_kyn()";

	readInit(fp,"=");
	if (gen_readNomVelAcc (fxnName, kyn->gen) == -1)
	 { return (-1);
	 }

	kyn->gen->dh[0].alpha = -PI/2;

	/* ---- Configuration codes ---- */
	kyn->gen->numConf = 1;
	
	/* ---- Instantiate function fields ---- */

	kyn->gen->fwdKinematics = linearFwdKinematics;
	kyn->gen->invKinematics = linearInvKinematics;
	kyn->gen->rangeAngles = linearRangeAngles;
	kyn->gen->solveConf = linearSolveConf;
	kyn->gen->fwdJacob = linearFwdJacob;
	kyn->gen->invJacob = linearInvJacob;
	kyn->gen->fwdJacobT = linearFwdJacobT;
	kyn->gen->invJacobT = linearInvJacobT;
	kyn->gen->gravload = linearGravload;
	kyn->gen->fwdJacobVar = linearFwdJacobVar;
	kyn->gen->invJacobVar = linearInvJacobVar;
	kyn->gen->fwdJacobTVar = linearFwdJacobTVar;
	kyn->gen->invJacobTVar = linearInvJacobTVar;
	kyn->gen->gravloadVar = linearGravloadVar;
	kyn->gen->updateVar = linearUpdateVar;
	kyn->gen->updateVarXsincos = linearUpdateVarXsincos;

	kyn->gen->rbtclass = LINEAR;

	return (1);
}
