/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd.			    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#include "../h/cdefs.h"
#include "../h/robot_jls.h"

puma_jls (jls)
JLS *jls;
{
	extern puma_angleToEncoder();
	extern puma_encoderToAngle();
	extern puma_jointToEncoder();
	extern puma_encoderToJoint();
	extern puma_jtorqueToMtorque();
	extern puma_mtorqueToJtorque();

	extern angleToEncoder();
	extern encoderToAngle();
	extern jointToEncoder();
	extern encoderToJoint();
	extern jtorqueToMtorque();
	extern mtorqueToJtorque();

	/* Check that the coupling indices are appropriate for
	   the puma functions. If not, use the generic functions. */

	if (jls->numFC == 3 && 
	    jls->forCouplings[0][0] == 4 && jls->forCouplings[0][1] == 3 &&
	    jls->forCouplings[1][0] == 5 && jls->forCouplings[1][1] == 3 &&
	    jls->forCouplings[2][0] == 5 && jls->forCouplings[2][1] == 4)
	 { 
	   jls->angleToEncoder = puma_angleToEncoder;
	   jls->encoderToAngle = puma_encoderToAngle;
	   jls->jointToEncoder = puma_jointToEncoder;
	   jls->encoderToJoint = puma_encoderToJoint;
	   jls->mtorqueToJtorque = puma_mtorqueToJtorque;
	   jls->jtorqueToMtorque = puma_jtorqueToMtorque;
	 }
	else
	 { 
	   jls->angleToEncoder = angleToEncoder;
	   jls->encoderToAngle = encoderToAngle;
	   jls->jointToEncoder = jointToEncoder;
	   jls->encoderToJoint = encoderToJoint;
	   jls->mtorqueToJtorque = mtorqueToJtorque;
	   jls->jtorqueToMtorque = jtorqueToMtorque;
	 }
	return (1);
}
