#ifndef _JOINTBLEND_H_
#define _JOINTBLEND_H_

/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1991 by John E. Lloyd.				    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

/*---------------------------------------------------------------------------
 *
 * DESCRIPTION:	Defines the structure which holds the coefficients for 
 *		blending together two joint path segments.
 * 
 * AUTHOR/DATE:	John Lloyd, October 1986
 *
 * MODIFICATION HISTORY:
 *
 *--------------------------------------------------------------------------*/

#include "../h/rcclDefs.h"

typedef struct {
	JNTS A0;		/* Coefficients for 5th order Hermite */
	JNTS A1;		/*    correction polynominal */
	JNTS A3;		/*    ...    */
	JNTS A4;
	JNTS A5;
} JOINT_BLEND_PARAMS;

void setJointBlend1 PROTO((JOINT_BLEND_PARAMS *jbp, JNTS *j1, JNTS *j2, 
			   int numJ));
void setJointBlend2 PROTO((JOINT_BLEND_PARAMS *jbp, JNTS *j1, JNTS *j2, 
			   double time, int numJ));
void applyJointBlend PROTO((JNTS *result, JOINT_BLEND_PARAMS *jbp, JNTS *jnts, 
			  double t, int numJ));

#endif
