#include <stdio.h>
#include <signal.h>
#include "../h/rccl.h"

MANIP *mnp;

SIGHAN_RETURN onCompleted ()
{
	CompletionQueueEntry ent;

	while (completionQueueTest (mnp))
	 { if (completionQueueRead (mnp, &ent) == 0)
	    { fprintf (stderr, "read returns 0 with something on queue\n");
	      exit (1);
	    }
	   printf ("mid=%d\n", ent.mid);
	   printJf ("%8.3f\n", ent.j6.v, mnp->jls->numJ);
	 }
	signal (SIGUSR1, onCompleted);
}

main()
{
	JNTS jc;
	TRSF *Tc;
	POS *pos;

	rcclSetOptions (RCCL_ERROR_EXIT);

	mnp = rcclCreate (getDefaultRobot(), 0);

	Tc = allocTrans (NULL, UNDEF);
	pos = makePosition (NULL, T6, EQ, Tc, TL, NULL);

	rcclStart();

#if 1
	signal (SIGUSR1, onCompleted);

	setEveryStopSig (mnp, SIGUSR1);
#endif

#if 1
	jc = *mnp->j6;
	jc.v[0] += 20*DEGTORAD;
	movej (mnp, &jc);

	waitForCompleted(mnp);

	jc.v[0] -= 20*DEGTORAD;
	movej (mnp, &jc);
/*	movej (mnp, &jc); */
	stop (mnp, 0.0);
#else
	*Tc = *mnp->t6;
	Tc->p.y += 50.0;
	move (mnp, pos);
	Tc->p.y -= 50.0;
	move (mnp, pos);
	stop (mnp, 0.0);
#endif


	waitForCompleted(mnp);
	nap (0.5);

	rcclRelease (0);

	printf ("\nROUTINES OK\n\n");
}
