/* simple program to test basic motions with the ACME gantry */

#include "../h/rccl.h"

main()
{
	MANIP *mnp;
	POS *pos;
	TRSF *TA;
	JNTS j5;

	rcclSetOptions (EXIT_ON_ERROR);
	mnp = rcclCreate ("gantry", 0);

	TA = allocTrans (NULL, UNDEF);
	pos = makePosition (NULL, T6, EQ, TA, NULL);

	rcclStart();
	rcclBlock();
	readTrans (mnp->t6, TA);
	j5 = *mnp->j6;

	/* move to a couple of points in joint mode: */

	setMod (mnp, 'j');
	multTrsfXyz (TA, 500, 500, -100);
	move (mnp, pos);
	multTrsfXyz (TA, -1000, -1000, 0);
	move (mnp, pos);
	multTrsfXyz (TA, 500, 500, 100);
	move (mnp, pos);
	waitfor (mnp->completed);

	/* now repeat in Cartesian mode: */
	
	setMod (mnp, 'j');
	multTrsfXyz (TA, 500, 500, -100);
	move (mnp, pos);
	multTrsfXyz (TA, -1000, -1000, 0);
	move (mnp, pos);
	multTrsfXyz (TA, 500, 500, 100);
	move (mnp, pos);
	waitfor (mnp->completed);

	/* and now repeat using joint coordinates instead */
	j5.v[0] += 500;
	j5.v[1] += 500;
	j5.v[2] += 100;
	movej (mnp, &j5);
	j5.v[0] -= 1000;
	j5.v[1] -= 1000;
	movej (mnp, &j5);
	j5.v[0] += 500;
	j5.v[1] += 500;
	j5.v[2] -= 100;
	movej (mnp, &j5);
	waitfor (mnp->completed);	

	rcclRelease (1);	
}
