/* simple program to test basic motions with the ACME stage */

#include "../h/rccl.h"

main()
{
	MANIP *mnp;
	POS *pos;
	TRSF *TA;
	JNTS j5;

	rcclSetOptions (EXIT_ON_ERROR);
	mnp = rcclCreate ("linear", 0);

	TA = allocTrans (NULL, UNDEF);
	pos = makePosition (NULL, T6, EQ, TA, NULL);

	rcclStart();
	rcclBlock();
	readTrans (mnp->t6, TA);
	j5 = *mnp->j6;

	/* move to a couple of points in joint mode: */

	setMod (mnp, 'j');
	multTrsfXyz (TA, 200, 0, 0);
	move (mnp, pos);
	multTrsfXyz (TA, -400, 0, 0);
	move (mnp, pos);
	multTrsfXyz (TA, 200, 0, 0);
	move (mnp, pos);
	waitfor (mnp->completed);

	/* now repeat in Cartesian mode: */
	
	setMod (mnp, 'j');
	multTrsfXyz (TA, 200, 0, 0);
	move (mnp, pos);
	multTrsfXyz (TA, -400, 0, 0);
	move (mnp, pos);
	multTrsfXyz (TA, 200, 0, 0);
	move (mnp, pos);
	waitfor (mnp->completed);

	/* and now repeat using joint coordinates instead */
	j5.v[0] += 200;
	movej (mnp, &j5);
	j5.v[0] += -400;
	movej (mnp, &j5);
	j5.v[0] += 200;
	movej (mnp, &j5);
	waitfor (mnp->completed);	

	rcclRelease (1);	
}

