/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1991 by John E. Lloyd.				    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
#define PAGESIZE   4096

#include <stdlib.h>

#ifdef HAS_UNISTD_H
#include <unistd.h>
#endif

char **argvec;

irandom (low, high)
int low, high;
{
	return (drand48()*(high-low) + low);
}

syspagesize()
{
#ifdef HAS_UNISTD_H
	return (sysconf (_SC_PAGESIZE));
#else
	return (getpagesize());
#endif
}

main(argc, argv)
int argc;
char **argv;
{
	int i;
	int pagesize;
	int size;
	char *addr;
	int message = 0;

	argvec = argv;

	argc--; argv++;
	if (argc != 1)
	 { printf ("Usage: %s <allocation size (hex)>\n", argvec[0]);
	   exit (-1);
	 }
	sscanf (*argv, "%x", &size);
	pagesize = syspagesize();
	printf ("pagesize=%d\n", pagesize);
	printf ("allocating %d pages\n", size/pagesize);

	addr = (char*)sbrk(size);
	if (addr == NULL)
	 { printf ("Couldn't allocate that much memory\n");
	   exit (1);
	 }
	for (i=0; i<size; )
	 { addr[i] = i;
	   addr[irandom(0,size-1)] = i;
	   if ((i += pagesize) >= size)
	    { i = 0;
	      if (message == 0)
	       { printf ("all memory hit\n");
		 message = 1;
	       }
	    }
	 }
}

	
