#include "../h/rciTimeLog.h"
#include <stdio.h>

static TimeLog *rciTimeLog;

Tval rcclTime0;
Tval rcclTime1;
Tval rcclTime2;
Tval rcclTime3;
Tval rcclTime4;

void rciTimeLogCreate (int size)
{
	TimeLog *log;
	log = (TimeLog*)malloc(sizeof(TimeLog));
	log->idx = 0;
	log->bufsize = size;
	log->recbuf = (TimeRec*)malloc(sizeof(TimeRec)*size);
	rciTimeLog = log;
}

void rciTimeLogPut ()
{
	TimeLog *log = rciTimeLog;
	int i;
	extern Tval rcclTime0;
	extern Tval rcclTime1;
	extern Tval rcclTime2;
	extern Tval rcclTime3;
	extern Tval rcclTime4;

	if (log == NULL)
	 { return;
	 }
	i = log->idx;
	if (i < log->bufsize)
	 { log->recbuf[i].time0 = rcclTime0;
	   log->recbuf[i].time1 = rcclTime1;
	   log->recbuf[i].time2 = rcclTime2;
	   log->recbuf[i].time3 = rcclTime3;
	   log->recbuf[i].time4 = rcclTime4;
	   log->idx++;
	 }
}

void rciTimeLogWrite (char *filename)
{
	TimeLog *log = rciTimeLog;
	Tval diff0;
	Tval diff1;
	Tval diff2;
	Tval diff3;
	Tval diff4;
	FILE *fp;
	int i;

	if (log == NULL)
	 { return;
	 }
	if ((fp = fopen (filename, "w")) == NULL)
	 { perror ("timeLogWrite");
	   exit (1);
	 }
       	for (i=0; i<log->idx; i++)
	 {
	   diff0 = subTval (log->recbuf[i].time1, log->recbuf[i].time0);
	   diff1 = subTval (log->recbuf[i].time2, log->recbuf[i].time1);
	   diff2 = subTval (log->recbuf[i].time3, log->recbuf[i].time2);
	   diff3 = subTval (log->recbuf[i].time4, log->recbuf[i].time3);
	   diff4 = subTval (log->recbuf[i].time4, log->recbuf[i].time0);
	   fprintf (fp, 
"%06d %06d %06d %06d %06d\n",
		  diff0.tv_usec,
		  diff1.tv_usec,
		  diff2.tv_usec,
		  diff3.tv_usec,
		  diff4.tv_usec);
	 }
	fclose (fp);
	printf ("LOGGED\n");
}

void rciTimeLogDelete ()
{
	TimeLog *log = rciTimeLog;
	free (log->recbuf);
	free (log);
	rciTimeLog = NULL;
}

int rciTimeLogNumEntries()
{
	TimeLog *log = rciTimeLog;
	if (log == NULL)
	 { return -1;
	 }
	else
	 { return log->idx;
	 }
}

int rciTimeLogSize()
{
	TimeLog *log = rciTimeLog;
	if (log == NULL)
	 { return -1;
	 }
	else
	 { return log->bufsize;
	 }
}
