#ifndef _ROBOTDEFS_H_
#define _ROBOTDEFS_H_

/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1991 by John E. Lloyd.				    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
/*---------------------------------------------------------------------------
 *
 * DESCRIPTION: Data structure describing what is read out of the robot
 *		configuration file (by readRobotFile()). This information is
 *		used by the function rciAttachRobot.
 * 
 * AUTHOR/DATE:	John Lloyd, Fall 1987
 *
 * MODIFICATION HISTORY:
 *
 *--------------------------------------------------------------------------*/

#include "../h/IOdevice.h"

typedef struct _ROBOT_DEFS {
	struct _ROBOT_DEFS *prev;
	struct _ROBOT_DEFS *next;

	char *name;		/* name of the robot */
	char *device;		/* name of the device for the robot */
	int address;		/* address of the device */
	int addressSet;
	char *addrStr;		/* other address information */
	int args[MAX_DEVARGS];	/* arguments for device driver */
	char *interruptDev;	/* interrupt device (for running on arbiter) */
	int intraddr;		/* interrupt address (for non-UNIX systems) */
	int intraddrSet;
	int vector;		/* vector (for non-UNIX systems) */
	int vectorSet;
	int ipl;		/* ipl (for non-UNIX systems) */
	int iplSet;		
} ROBOT_DEFS;

#endif
