#include <stdio.h>
#include "tgen.h"
#include "../h/cdefs.h"

TRSF T61, T62, T63;

typedef struct {
	double m1, d1, m2, d2;
	TRSF *T6;
	int xCmd;
} TestRec;

TestRec testData[] = {
	1.085, 	162.6,	0,	0,	&T61,	1,
	1.085,	162.6,  1.092,	-162.6,	&T61,	1,
	0,	0,      1.092,	-162.6,	&T61,	1,

	1.085, 	162.6,	0,	0,	&T62,	1,
	1.085,	162.6,  1.092,	-162.6,	&T62,	1,
	0,	0,      1.092,	-162.6,	&T62,	1,

	1.085, 	162.6,	0,	0,	&T63,	0,
	1.085,	162.6,  1.092,	-162.6,	&T63,	0,
	0,	0,      1.092,	-162.6,	&T63,	0
};

TRSF ST, JT;

main()
{
	int i;

	identTrsf (&T61);
	xyzToTrsf (&T61, 357.72, 0, 300.1694);
	rpyToTrsf (&T62, 90.0, 45.0, 90.0);
	xyzToTrsf (&T62, 357.72, 0, 300.1694);
	rpyToTrsf (&T63, -90.0, 45.0, -90.0);
	xyzToTrsf (&T63, 357.72, 0, 300.1694);

	/* Definitions for ST and JT */

	identTrsf (&ST);
	identTrsf (&JT);
	xyzToTrsf (&ST, 0, 0, 101.4);
	xyzToTrsf (&JT, 0, 0, 9.2);
	rpyToTrsf (&JT, 45, 0, 0);
	
	for (i=0; i<ARRAY_SIZE(testData); i++)
	 { dotest (&testData[i], i);
	 }
}

dotest(rec, i)
TestRec *rec;
int i;
{
       	TRSF TT, D1, D2, FT1, FT2;
	FORCE g, f1, f2, ftotal;

	TT = *rec->T6;
	multTrsf (&TT, &TT, &ST);
	multTrsf (&TT, &TT, &JT);
	identTrsf (&D1);
	identTrsf (&D2);
	if (rec->xCmd)
	 { xyzToTrsf (&D1, rec->d1, 0, 0);
	   xyzToTrsf (&D2, rec->d2, 0, 0);
	 }
	else
	 { xyzToTrsf (&D1, 0, rec->d1, 0);
	   xyzToTrsf (&D2, 0, rec->d2, 0);
	 }
	invertTrsf (&FT1, &JT);
	multLiTrsf (&FT1, &D1, &FT1);
	invertTrsf (&FT2, &JT);
	multLiTrsf (&FT2, &D2, &FT2);

	zeroForce (&g);
	g.f.z = rec->m1 * 9.8;
	rotateVect (&g.f, &g.f, &TT);
	transForce (&f1, &g, &FT1);

	zeroForce (&g);
	g.f.z = rec->m2 * 9.8;
	rotateVect (&g.f, &g.f, &TT);
	transForce (&f2, &g, &FT2);

	addVf ((float*)&ftotal, (float*)&f1, (float*)&f2, 6);

	printVf ("%11.5f\n", (float*)&ftotal, 6);
}
