#ifdef Tsp_TARGET         

#include <stdio.h>
#include <cdefs.h>        
#include <conc.h>
#include "tgen.h"
#include "tgenTsp.h"
#include "servo.h"
#include <vector.h>
#include <puma_kynvar.h>
#include <robotTypes.h>

#define SEC_TO_TICKS    (1000000/64.)

extern int forceFilterWin;
extern int useReducedForce;

#define BUFSIZE	256

int bcnt = 0;
int dbuf[BUFSIZE][6];

doMonitor (tg, arg, ptr)
Tgen *tg;
int arg;
void *ptr;
{
	TspTgenCtrl *ctrl;
	ctrl = tg->ctrl;

	if (bcnt < BUFSIZE)
	 { bcopy (ctrl->rawForceData, dbuf[bcnt++], 6*sizeof(int));
	 }
}

main()
{
	JntVec jc;
	TRSF TC, TH;
	Tgen *tg;
	TspTgenCtrl *ctrl;
	TRSF FStoTOOL;
	int i, j;

	identTrsf (&FStoTOOL);
	xyzToTrsf (&FStoTOOL, 0, 0, 100.0);

	printf ("Allocating trajectory generator ...\n");

	if ((tg = tgenAlloc ("caesar")) == NULL)
	 { printErrors ();
	   exit (1);
	 }
	printf ("done\n");

	tgenSetCartVel (tg, 200.0, -1);
	tgenSetCartAcc (tg, 1000.0, -1);

	forceFilterWin = 1;

	printf ("Starting trajectory generator ...\n");
	if (tgenStart (tg, 0.005, LINK3OUT, LINK3IN, LINK2OUT, LINK2IN) < 0)
	 { printErrors();
	   exit (1);
	 }
	printf ("done\n");

	ctrl = (TspTgenCtrl*)tg->ctrl;
#if 0
	if (getRobotPosition (jc.v, "demohome", "caesar") < 0)
	 { printErrors();
	   exit (1);
	 }
	printf ("moving to demohome (confirm):\n");
	while (getchar() != '\n')
	   ;
	tgenMoveJ (tg, &jc);

	do
	 { ProcWait (0.2*SEC_TO_TICKS);
	 }
	while (tgenIsBusy(tg));

	printf ("There.\n");
#endif
	ctrl->resetBias = 1;
	
	ProcWait (SEC_TO_TICKS);
	tgenMonitorFxnSet (tg, doMonitor, 0, (void*)0);

	for (i=0; i<10000; i++)
	 { ProcWait (SEC_TO_TICKS/2);
#if 1
	    { int rawData[6];
	      int rawDel[6];
	      FORCE force1, force2;
	      TRSF T6real;
	      JntVec j6real;
	      extern int forceGetTime;

	      printf ("%d\n", 64*forceGetTime);

	      ProcToHigh();
	      bcopy (&tg->force, &force1, sizeof(FORCE));
	      bcopy (ctrl->rawForceDel, rawDel, 6*sizeof(int));
	      bcopy (ctrl->rawForceData, rawData, 6*sizeof(int));
	      bcopy (&tg->T6real, &T6real, sizeof(TRSF));
	      bcopy (&tg->j6real, &j6real, sizeof(JntVec));
	      ProcToLow();

	      transForce (&force2, &force1, &FStoTOOL);
#if 0
	      printJf ("J6:     %8.3f\n", tg->j6.v, 6);
	      printJf ("J6real: %8.3f\n", j6real.v, 6);
	      printVi ("Bias:   %4d\n", ctrl->rawForceBias, 6);
#endif
	      printVi ("Del:    %4d\n", rawDel, 6);
	      printVi ("Data:   %4d\n", rawData, 6);
/*	      printVf ("Force:  %9.4f\n\n", (float*)&force2, 6); */
	    }
#endif
	 }
	tgenRelease(tg);
	for (i=0; i<bcnt; i++)
	 { printVi ("%4d\n", dbuf[i], 6);
	 }
}

#endif
