#if defined(Vxw_TARGET)

#include <vxWorks.h>
#include <symLib.h>

static char msgBuf[256];

char *errorstr()
{
	
	extern SYMTAB *statSymTbl;
	int error;
	int val;

	error = errnoGet();
	if (symFindByValue(statSymTbl, error, msgBuf, &val, NULL) == ERROR ||
	    val != error)
	 {  sprintf (msgBuf, "Unknown error (0x%x)", error);
	 }
	return (msgBuf);
}

#elif defined(Tsp_TARGET)

extern int errno;

char *errorstr()
{
	static char buf[64];
	sprintf (buf, "Error %d (message strings unknown on Tsp's)", errno);
	return (buf);
}

#else /* default */

#include <stdio.h>
#include <errno.h>

extern int sys_nerr;
#ifndef Sgi_TARGET
extern const char *const sys_errlist[];
#endif

char *errorstr()
{
	char *msg;

	if (errno < sys_nerr)
	 { msg = sys_errlist[errno];
	 }
	else
	 { static char buf[64];
	   msg = buf;
	   sprintf(msg,"Unknown error (%d)",errno);
	 }
	return(msg);
}
#endif
