#include "../h/stringDefs.h"
#include "../h/cdefs.h"

char *copyofstr(str)
const char *str;
{
	char *cp;
	char *malloc();

	if (str == 0)
	 { return(0);
	 }
	cp = malloc(strlen(str)+1);
	if (cp == 0)
	 { return(0);
	 }
	strcpy(cp,str);
	return(cp);
}

char *copyofblk(blk,len)
const char *blk;
int len;
{
	char *cp;
	char *malloc();

	if (blk == 0)
	 { return(0);
	 }
	cp = malloc(len);
	if (cp == 0)
	 { return(0);
	 }
	BCOPY(blk,cp,len);
	return(cp);
}

char *charIndex (s1, c)
const char *s1;
int c;
{
	if (s1 == NULL)
	 { return (NULL);
	 }
	for ( ; *s1 != '\0'; s1++)
	 { if (*s1 == c)
	    { return ((char*)s1);
	    }
	 }
	return (NULL);
}

char *charRindex (s1, c)
const char *s1;
int c;
{
	const char *s2;

	if (s1 == NULL)
	 { return (NULL);
	 }
	for (s2=s1; *s2 != '\0'; s2++)
	   ;
	for (s2--; s2 >= s1; s2--)
	 { if (*s2 == c)
	    { return ((char*)s2);
	    }
	 }
	return (NULL);
}

#if defined(NO_MEMCPY) && defined(NO_BCOPY_EITHER)

void *memcpy (s1, s2, len)
void *s1;
const void *s2;
int len;
{
	unsigned char *cp1, *cp2;

	cp1 = s1;
	cp2 = s2;
	while (len-- > 0)
	 { *cp1++ = *cp2++;
	 }
	return (s1);
}

void *memset (s1, val, len)
void *s1;
int val, len;
{
	unsigned char *cp1;

	cp1 = s1;
	while (len-- > 0)
	 { *cp1++ = val;
	 }
	return (s1);
}

int memcmp (s1, s2, len)
const void *s1, *s2;
int len;
{
	unsigned char *cp1, *cp2;
	unsigned char c1, c2;

	cp1 = s1;
	cp2 = s2;
	while (len-- > 0)
	 { c1 = *cp1++;
	   c2 = *cp2++;
	   if (c1 != c2)
	    { return ((c1 < c2) ? -1 : 1);
	    }
	 }
	return (0);
}

#endif

#ifdef TEST
#include <stdio.h>

bail(loc, s)
int loc;
char *s;
{
	fprintf (stderr, "%d::%s\n", loc, s);
	exit (1);
}

checkIdx (loc, s1, s2)
int loc;
char *s1;
char *s2;
{
	if (s1 != s2)
	 { bail (loc, "checkIdx");
	 }
}

main()
{
	char s1[11] = "abfooXbg1o";

	checkIdx (100, charIndex(s1, 'z'), NULL);
	checkIdx (101, charIndex(s1, 'a'), s1);
	checkIdx (102, charIndex(NULL, 'a'), NULL);
	checkIdx (103, charIndex(s1, 'b'), &s1[1]);
	checkIdx (104, charIndex(s1, 'o'), &s1[3]);

	checkIdx (105, charRindex(s1, 'z'), NULL);
	checkIdx (106, charRindex(s1, 'a'), s1);
	checkIdx (107, charRindex(NULL, 'a'), NULL);
	checkIdx (108, charRindex(s1, 'b'), &s1[6]);
	checkIdx (109, charRindex(s1, 'o'), &s1[9]);

	printf ("\nRoutines OK\n\n");
}
#endif
