/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)syscalls.c	7.1 (Berkeley) 6/5/86
 */

/*
 * System call names.
 */
char *syscallnames[] = {
	"indir",		/*   0 = indir */
	"exit",			/*   1 = exit */
	"fork",			/*   2 = fork */
	"read",			/*   3 = read */
	"write",		/*   4 = write */
	"open",			/*   5 = open */
	"close",		/*   6 = close */
	"old wait",		/*   7 = old wait */
	"creat",		/*   8 = creat */
	"link",			/*   9 = link */
	"unlink",		/*  10 = unlink */
	"execv",		/*  11 = execv */
	"chdir",		/*  12 = chdir */
	"old time",		/*  13 = old time */
	"mknod",		/*  14 = mknod */
	"chmod",		/*  15 = chmod */
	"chown",		/*  16 = chown; now 3 args */
	"old break",		/*  17 = old break */
	"old stat",		/*  18 = old stat */
	"lseek",		/*  19 = lseek */
	"getpid",		/*  20 = getpid */
	"mount",		/*  21 = mount */
	"umount",		/*  22 = umount */
	"old setuid",		/*  23 = old setuid */
	"getuid",		/*  24 = getuid */
	"old stime",		/*  25 = old stime */
	"ptrace",		/*  26 = ptrace */
	"old alarm",		/*  27 = old alarm */
	"old fstat",		/*  28 = old fstat */
	"old pause",		/*  29 = old pause */
	"old utime",		/*  30 = old utime */
	"old stty - nosys",	/*  31 = old stty */
	"old gtty - nosys",	/*  32 = old gtty */
	"access",		/*  33 = access */
	"old nice",		/*  34 = old nice */
	"old ftime",		/*  35 = old ftime */
	"sync",			/*  36 = sync */
	"kill",			/*  37 = kill */
	"stat",			/*  38 = stat */
	"old setpgrp",		/*  39 = old setpgrp */
	"lstat",		/*  40 = lstat */
	"dup",			/*  41 = dup */
	"pipe",			/*  42 = pipe */
	"old times",		/*  43 = old times */
	"profil",		/*  44 = profil */
	"#45",			/*  45 = nosys */
	"old setgid",		/*  46 = old setgid */
	"getgid",		/*  47 = getgid */
	"old signal",		/*  48 = old sig */
	"#49",			/*  49 = reserved for USG */
	"#50",			/*  50 = reserved for USG */
	"acct",			/*  51 = turn acct off/on */
	"old phys - nosys",	/*  52 = old set phys addr */
	"old lock - nosys",	/*  53 = old lock in core */
	"ioctl",		/*  54 = ioctl */
	"reboot",		/*  55 = reboot */
	"old mpx - nosys",	/*  56 = old mpxchan */
	"symlink",		/*  57 = symlink */
	"readlink",		/*  58 = readlink */
	"execve",		/*  59 = execve */
	"umask",		/*  60 = umask */
	"chroot",		/*  61 = chroot */
	"fstat",		/*  62 = fstat */
	"#63",			/*  63 = used internally */
	"getpagesize",		/*  64 = getpagesize */
	"mremap",		/*  65 = mremap */
	"vfork",		/*  66 = vfork */
	"old vread - read",	/*  67 = old vread */
	"old vwrite - write",	/*  68 = old vwrite */
	"sbrk",			/*  69 = sbrk */
	"sstk",			/*  70 = sstk */
	"mmap",			/*  71 = mmap */
	"old vadvise",		/*  72 = old vadvise */
	"munmap",		/*  73 = munmap */
	"mprotect",		/*  74 = mprotect */
	"madvise",		/*  75 = madvise */
	"vhangup",		/*  76 = vhangup */
	"old vlimit",		/*  77 = old vlimit */
	"mincore",		/*  78 = mincore */
	"getgroups",		/*  79 = getgroups */
	"setgroups",		/*  80 = setgroups */
	"getpgrp",		/*  81 = getpgrp */
	"setpgrp",		/*  82 = setpgrp */
	"setitimer",		/*  83 = setitimer */
	"wait",			/*  84 = wait */
	"swapon",		/*  85 = swapon */
	"getitimer",		/*  86 = getitimer */
	"gethostname",		/*  87 = gethostname */
	"sethostname",		/*  88 = sethostname */
	"getdtablesize",	/*  89 = getdtablesize */
	"dup2",			/*  90 = dup2 */
	"getdopt",		/*  91 = getdopt */
	"fcntl",		/*  92 = fcntl */
	"select",		/*  93 = select */
	"setdopt",		/*  94 = setdopt */
	"fsync",		/*  95 = fsync */
	"setpriority",		/*  96 = setpriority */
	"socket",		/*  97 = socket */
	"connect",		/*  98 = connect */
	"accept",		/*  99 = accept */
	"getpriority",		/* 100 = getpriority */
	"send",			/* 101 = send */
	"recv",			/* 102 = recv */
	"sigreturn",		/* 103 = sigreturn */
	"bind",			/* 104 = bind */
	"setsockopt",		/* 105 = setsockopt */
	"listen",		/* 106 = listen */
	"old vtimes",		/* 107 = old vtimes */
	"sigvec",		/* 108 = sigvec */
	"sigblock",		/* 109 = sigblock */
	"sigsetmask",		/* 110 = sigsetmask */
	"sigpause",		/* 111 = sigpause */
	"sigstack",		/* 112 = sigstack */
	"recvmsg",		/* 113 = recvmsg */
	"sendmsg",		/* 114 = sendmsg */
#ifdef TRACE
	"old vtrace",		/* 115 = old vtrace */
#else
	"#115",			/* 115 = nosys */
#endif
	"gettimeofday",		/* 116 = gettimeofday */
	"getrusage",		/* 117 = getrusage */
	"getsockopt",		/* 118 = getsockopt */
#ifdef vax
	"resuba",		/* 119 = resuba */
#else
	"#119",			/* 119 = nosys */
#endif
	"readv",		/* 120 = readv */
	"writev",		/* 121 = writev */
	"settimeofday",		/* 122 = settimeofday */
	"fchown",		/* 123 = fchown */
	"fchmod",		/* 124 = fchmod */
	"recvfrom",		/* 125 = recvfrom */
	"setreuid",		/* 126 = setreuid */
	"setregid",		/* 127 = setregid */
	"rename",		/* 128 = rename */
	"truncate",		/* 129 = truncate */
	"ftruncate",		/* 130 = ftruncate */
	"flock",		/* 131 = flock */
	"old portal - nosys",	/* 132 = old portal */
	"sendto",		/* 133 = sendto */
	"shutdown",		/* 134 = shutdown */
	"socketpair",		/* 135 = socketpair */
	"mkdir",		/* 136 = mkdir */
	"rmdir",		/* 137 = rmdir */
	"utimes",		/* 138 = utimes */
	"4.2 sigreturn",	/* 139 = old 4.2 sigreturn */
	"adjtime",		/* 140 = adjtime */
	"getpeername",		/* 141 = getpeername */
	"gethostid",		/* 142 = gethostid */
	"sethostid",		/* 143 = sethostid */
	"getrlimit",		/* 144 = getrlimit */
	"setrlimit",		/* 145 = setrlimit */
	"killpg",		/* 146 = killpg */
	"#147",			/* 147 = nosys */
	"setquota",		/* 148 = setquota */
	"quota",		/* 149 = quota */
	"getsockname",		/* 150 = getsockname */
	"#151",			/* 151 = nosys */
	"#152",			/* 152 = nosys */
	"#153",			/* 153 = nosys */
	"#154",			/* 154 = nosys */
	"#155",			/* 155 = nosys */
	"#156",			/* 156 = nosys */
	"#157",			/* 157 = nosys */
	"#158",			/* 158 = nosys */
	"#159",			/* 159 = nosys */
	"#160",			/* 160 = nosys */
	"#161",			/* 161 = nosys */
	"#162",			/* 162 = nosys */
	"#163",			/* 163 = nosys */
	"#164",			/* 164 = nosys */
	"#165",			/* 165 = nosys */
	"#166",			/* 166 = nosys */
	"#167",			/* 167 = nosys */
	"#168",			/* 168 = nosys */
	"#169",			/* 169 = nosys */
	"#170",			/* 170 = nosys */
	"#171",			/* 171 = nosys */
	"#172",			/* 172 = nosys */
	"#173",			/* 173 = nosys */
	"#174",			/* 174 = nosys */
	"#175",			/* 175 = nosys */
	"#176",			/* 176 = nosys */
	"#177",			/* 177 = nosys */
	"#178",			/* 178 = nosys */
	"#179",			/* 179 = nosys */
	"#180",			/* 180 = nosys */
	"#181",			/* 181 = nosys */
	"#182",			/* 182 = nosys */
	"#183",			/* 183 = nosys */
	"#184",			/* 184 = nosys */
	"#185",			/* 185 = nosys */
	"#186",			/* 186 = nosys */
	"#187",			/* 187 = nosys */
	"#188",			/* 188 = nosys */
	"#189",			/* 189 = nosys */
	"#190",			/* 190 = nosys */
	"#191",			/* 191 = nosys */
	"#192",			/* 192 = nosys */
	"#193",			/* 193 = nosys */
	"#194",			/* 194 = nosys */
	"#195",			/* 195 = nosys */
	"#196",			/* 196 = nosys */
	"#197",			/* 197 = nosys */
	"#198",			/* 198 = nosys */
	"#199",			/* 199 = nosys */
	"#200",			/* 200 = nosys */
	"#201",			/* 201 = nosys */
	"#202",			/* 202 = nosys */
	"#203",			/* 203 = nosys */
	"#204",			/* 204 = nosys */
	"#205",			/* 205 = nosys */
	"#206",			/* 206 = nosys */
	"#207",			/* 207 = nosys */
	"#208",			/* 208 = nosys */
	"#209",			/* 209 = nosys */
	"#210",			/* 210 = nosys */
	"#211",			/* 211 = nosys */
	"#212",			/* 212 = nosys */
	"#213",			/* 213 = nosys */
	"#214",			/* 214 = nosys */
	"#215",			/* 215 = nosys */
	"#216",			/* 216 = nosys */
	"#217",			/* 217 = nosys */
	"#218",			/* 218 = nosys */
	"#219",			/* 219 = nosys */
	"#220",			/* 220 = nosys */
	"#221",			/* 221 = nosys */
	"#222",			/* 222 = nosys */
	"#223",			/* 223 = nosys */
	"#224",			/* 224 = nosys */
	"#225",			/* 225 = nosys */
	"#226",			/* 226 = nosys */
	"#227",			/* 227 = nosys */
	"#228",			/* 228 = nosys */
	"#229",			/* 229 = nosys */
	"#230",			/* 230 = nosys */
	"#231",			/* 231 = nosys */
	"#232",			/* 232 = nosys */
	"#233",			/* 233 = nosys */
	"#234",			/* 234 = nosys */
	"#235",			/* 235 = nosys */
	"#236",			/* 236 = nosys */
	"#237",			/* 237 = nosys */
	"#238",			/* 238 = nosys */
	"#239",			/* 239 = nosys */
	"#240",			/* 240 = nosys */
	"#241",			/* 241 = nosys */
	"#242",			/* 242 = nosys */
	"#243",			/* 243 = nosys */
	"#244",			/* 244 = nosys */
	"#245",			/* 245 = nosys */
	"#246",			/* 246 = nosys */
	"#247",			/* 247 = nosys */
	"#248",			/* 248 = nosys */
	"#249",			/* 249 = nosys */
	"#250",			/* 250 = nosys */
	"#251",			/* 251 = nosys */
	"#252",			/* 252 = nosys */
	"#253",			/* 253 = nosys */
	"#254",			/* 254 = nosys */
	"#255",			/* 255 = nosys */
#ifdef LOCAL
	"cmkrnl",		/* 256 = cmkrnl */
	"loadavg",		/* 257 = loadavg */
#else
	"#256",			/* 256 = nosys */
	"#257",			/* 257 = nosys */
#endif
#ifdef MEMORYMAPPING
	"map",			/* 258 = map */
	"unmap",		/* 259 = unmap */
	"dumpmap",		/* 260 = dumpmap (unadvertised) */
	"slock",		/* 261 = slock */
	"sunlock",		/* 262 = sunlock */
	"secverbose",		/* 263 = secverbose (unadvertised) */
	"memlock",		/* 264 = memlock */
	"memunlock",		/* 265 = memunlock */
	"map_physical",		/* 266 = map_physical */
#else
	"#258",			/* 258 = nosys */
	"#259",			/* 259 = nosys */
	"#260",			/* 260 = nosys */
	"#261",			/* 261 = nosys */
	"#262",			/* 262 = nosys */
	"#263",			/* 263 = nosys */
	"#264",			/* 264 = nosys */
	"#265",			/* 265 = nosys */
	"#266",			/* 266 = nosys */
#endif
#ifdef ONEXIT
	"onexit",		/* 267 = onexit */
#else
	"#267",			/* 267 = nosys */
#endif
#ifdef SNAPSHOT
	"take_snapshot",	/* 268 = take_snapshot */
	"read_snapshot",	/* 269 = read_snapshot */
#else
	"#268",			/* 268 = nosys */
	"#269",			/* 269 = nosys */
#endif
};
