#ifndef _S16DIOCTL_H_
#define _S16DIOCTL_H_

#include <sys/ioccom.h>

#ifdef _SYS_IOCCOM_H
#   define R       'R'
#else
#   ifdef __STDC__
#      define R       'R'
#   else
#      define R        R
#   endif
#endif

/* get command register values, excluding the GO bit. Also,
   the DISINT bit has to be stored by the driver software, and
   so if this is set outside of the IOCTL interface, the
   driver won't be aware of it. */
#define S16D_GET_COMMAND	_IOR(R,1,u_short)

/* set command register */
#define S16D_SET_COMMAND	_IOW(R,2,u_short)

/* get the status register values */
#define S16D_GET_STATUS		_IOR(R,4,u_short)

/* get the config register values. These are stored in software in 
   the driver because the config register is write-only */
#define S16D_GET_CONFIG		_IOR(R,5,u_short)

/* set the config register values */
#define S16D_SET_CONFIG		_IOW(R,6,u_short)

#endif
